package com.uas.search.console.b2b.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

/**
 * 主动报价单
 * 
 * @author dongbw
 * @since 2016年11月11日 17:42:49
 */

@Entity
@Table(name = SaleQuotationSimpleInfo.TABLE_NAME)
public class SaleQuotationSimpleInfo {
	/**
	 * 表名
	 */
	public static final String TABLE_NAME = "SALE$QUOTATION";

	/**
	 * 各字段列名
	 * 
	 */
	public static final String ID_FIELD = "qu_id";

	public static final String CODE_FIELD = "qu_code";

	public static final String STATUS_FIELD = "qu_status";

	public static final String DATE_FIELD = "qu_date";

	public static final String ENTERPRISE_FIELD = "qu_enuu";

	public static final String VEND_FIELD = "qu_custuu";

	public static final String ITEMS_FIELD = "qd_quid";

	@Id
	@Column(name = ID_FIELD)
	private Long id;

	/**
	 * 报价单流水号
	 * 
	 */
	@Column(name = CODE_FIELD)
	private String code;

	/**
	 * 处理状态（101已提交、100未提交）
	 */
	@Column(name = STATUS_FIELD)
	private Short status;

	/**
	 * 日期
	 */
	@Column(name = DATE_FIELD)
	private Date date;

	/**
	 * 企业UU
	 */
	@OneToOne
	@JoinColumn(name = ENTERPRISE_FIELD, insertable = false, updatable = false)
	private EnterpriseSimpleInfo enterprise;

	/**
	 * 供应商
	 */
	@OneToOne
	@JoinColumn(name = VEND_FIELD, insertable = false, updatable = false)
	private EnterpriseSimpleInfo vend;

	/**
	 * 报价单明细
	 */
	@OneToMany(cascade = { CascadeType.ALL }, fetch = FetchType.EAGER)
	@JoinColumn(name = ITEMS_FIELD, updatable = false, insertable = false)
	private Set<SaleQuotationItemSimpleInfo> saleQuotationItems;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public Short getStatus() {
		return status;
	}

	public void setStatus(Short status) {
		this.status = status;
	}

	public EnterpriseSimpleInfo getVend() {
		return vend;
	}

	public void setVend(EnterpriseSimpleInfo vend) {
		this.vend = vend;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public EnterpriseSimpleInfo getEnterprise() {
		return enterprise;
	}

	public void setEnterprise(EnterpriseSimpleInfo enterprise) {
		this.enterprise = enterprise;
	}

	public Set<SaleQuotationItemSimpleInfo> getSaleQuotationItems() {
		return saleQuotationItems;
	}

	public void setSaleQuotationItems(Set<SaleQuotationItemSimpleInfo> saleQuotationItems) {
		this.saleQuotationItems = saleQuotationItems;
	}

	/**
	 * 获取所有可以搜索的字段列名（索引的field名）
	 * 
	 * @return 可以搜索的字段列名
	 */
	public static List<String> getKeywordFields() {
		List<String> fields = new ArrayList<>();
		fields.add(CODE_FIELD);
		fields.add(VEND_FIELD);
		fields.add(ITEMS_FIELD);
		return fields;
	}

	@Override
	public String toString() {
		return "SaleQuotationSimpleInfo [id=" + id + ", code=" + code + ", status=" + status + ", date=" + date
				+ ", enterprise=" + enterprise + ", vend=" + vend + ", saleQuotationItems=" + saleQuotationItems + "]";
	}

}
